
with CSSW_COMMON_TYPES;
with IASW_COMMON;
with IASW_DFEE;

package IASW_MODES is

   package CCT renames CSSW_COMMON_TYPES;

   subtype T_SCIENCE_FORMAT is CCT.T_UNSIGNED_16;

   -- Science TM format codes
   K_SCF_UNDEFINED   : constant T_SCIENCE_FORMAT := 0;
   K_SCF_DEFAULT     : constant T_SCIENCE_FORMAT := 255;
   K_SCF_TEST        : constant T_SCIENCE_FORMAT := 90;
   K_SCF_FULL        : constant T_SCIENCE_FORMAT := 1;
   K_SCF_SPECT_TIM   : constant T_SCIENCE_FORMAT := 2;
   K_SCF_RESTRICTED  : constant T_SCIENCE_FORMAT := 3;
   K_SCF_TIMING      : constant T_SCIENCE_FORMAT := 4;
   K_SCF_SPECTRUM    : constant T_SCIENCE_FORMAT := 5;
   K_SCF_CALIBRATION : constant T_SCIENCE_FORMAT := 20;
   K_SCF_DIAGNOSTIC  : constant T_SCIENCE_FORMAT := 40;


   ----------------------------------------------------------------
   -- Local procedures, made global because of possible patching --
   ----------------------------------------------------------------

   function CALCULATE_EVENT_SIZE(
      STATE : in IASW_DFEE.T_DFEE_STATE
   ) return IASW_COMMON.T_EVENT_SIZE;

   -----------------------
   -- Global procedures --
   -----------------------

   procedure STOP_DATA_TAKING (IMM : in BOOLEAN := FALSE);

   procedure START_DATA_TAKING (
      STATE : in IASW_DFEE.T_DFEE_STATE;
      SYNC  : in BOOLEAN;
      SF1   : in T_SCIENCE_FORMAT;
      SF2   : in T_SCIENCE_FORMAT;
      GFL1  : in CCT.T_UNSIGNED_16;
      GFL2  : in CCT.T_UNSIGNED_16);

   function IS_SCF_VALID(
      SCF   : in T_SCIENCE_FORMAT;
      STATE : in IASW_DFEE.T_DFEE_STATE;
      SYNC  : in BOOLEAN
   ) return BOOLEAN;

   function GET_DEFAULT_SCF(
      STATE : in IASW_DFEE.T_DFEE_STATE;
      SYNC  : in BOOLEAN
   ) return T_SCIENCE_FORMAT;

   procedure GET_DPE_STATE(DS : out IASW_COMMON.T_DPE_STATE);

   procedure CONSTRUCTOR;

end IASW_MODES;
