dnl
dnl This is the m4 macrogenerator source file.  It is used as the source of
dnl packages named IASW_SUBBUFFER_n where n is the integer number.  Please
dnl make changes *only* here.
dnl
dnl In order to generate package called IASW_SUBBUFFER_n do the following:
dnl   m4 -DPACKAGE_NAME=IASW_BUFFER_n -DHEAD iasw_subbuffer.m4 \
dnl     > iasw_subbuffer_n_.ada
dnl   m4 -DPACKAGE_NAME=IASW_BUFFER_n -DSUBBUFFER_SIZE=size -DBODY \
dnl     iasw_subbuffer.m4 > iasw_subbuffer_n.ada
dnl
changequote($,$)dnl
changecom(--)dnl

-- WARNING: This file is generated automatically from the source cointained in
-- iasw_subbuffer.m4 file.  Do not modify it under any circumstances, since
-- your changes will be discarded next time the "make" program is run.

ifdef($HEAD$,$dnl
with CSSW_COMMON_TYPES;  use CSSW_COMMON_TYPES;
with IASW_COMMON;
with IASW_BUFFER;

package PACKAGE_NAME is

   -- This local array is made global because of possible patching.
   SUBBUFFER_AREA : IASW_COMMON.T_EVENT_WRAPPER(0 .. SUBBUFFER_SIZE - 1);

   procedure ACCESS_EVENT(
      EVENT : in out IASW_COMMON.T_EVENT;
      INDEX : in IASW_BUFFER.T_BUFFER_INDEX;
      EVENT_SIZE : in IASW_COMMON.T_EVENT_SIZE;
      STORING : in BOOLEAN
   );
   function GET_SUBBUFFER_SIZE(
      EVENT_SIZE : in IASW_COMMON.T_EVENT_SIZE
   ) return IASW_BUFFER.T_BUFFER_INDEX;

end PACKAGE_NAME;
$)dnl
dnl
ifdef($BODY$,$dnl

package body PACKAGE_NAME is

   package CCT renames CSSW_COMMON_TYPES;

   ------------------------------------------------------------------------
   -- ACCESS_EVENT
   --
   -- This procedure is used to store given event in the sub-buffer at
   -- specified INDEX, or to retrieve an event from INDEX to given
   -- variable EVENT.  The action is determined by STORING.

   procedure ACCESS_EVENT(
      EVENT : in out IASW_COMMON.T_EVENT;
      INDEX : in IASW_BUFFER.T_BUFFER_INDEX;
      EVENT_SIZE : in IASW_COMMON.T_EVENT_SIZE;
      STORING : in BOOLEAN
   ) is
      OFFS : IASW_COMMON.T_EVENT_SIZE;
   begin
pragma Suppress(all_checks);
      OFFS := INDEX * EVENT_SIZE;
      if STORING then
         for I in 0 .. EVENT_SIZE - 1 loop
            SUBBUFFER_AREA (OFFS + I) := EVENT(I);
         end loop;
      else
         for I in 0 .. EVENT_SIZE - 1 loop
            EVENT(I) := SUBBUFFER_AREA (OFFS + I);
         end loop;
      end if;
   end ACCESS_EVENT;

   ------------------------------------------------------------------------
   -- GET_SUBBUFFER_SIZE.
   --
   -- Returns the amount of events that can fit into this sub-buffer.

   function GET_SUBBUFFER_SIZE(
      EVENT_SIZE : in IASW_COMMON.T_EVENT_SIZE
   ) return IASW_BUFFER.T_BUFFER_INDEX is
   begin
      return SUBBUFFER_SIZE / EVENT_SIZE;
   end GET_SUBBUFFER_SIZE;

end PACKAGE_NAME;
$)dnl
